/* Channel.h
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Die Datenstrukturen fr Server, Channels und Queries. */

#ifndef CHANNEL_H
#define CHANNEL_H

#include <forms.h>
#include <netinet/in.h>
#include <sys/time.h>

#include "Constants.h"
#include "Lists.h"

#include "../Forms/BanList.h"
#include "../Forms/TopicList.h"
#include "../Forms/Query.h"
#include "../Forms/Password.h"
#include "../Forms/MainWindow.h"

struct server
{
  struct channel *channel;
  struct list *querylist;
  struct in_addr myip;
  struct timeval isontime;
  unsigned long lag;
  int sock;
  int nickhistline;
  int histline;
  int connected;
  int cleartojoin;
  int isonreply;
  char name[MAXSERVER];
  char ircname[MAXSERVER];
  char currentnick[NICKLEN];
  char lastquery[NICKLEN];
  char nickhist[MAXNICKHIST][NICKLEN];
  char history[MAXLINEHIST][LINELEN];
  FILE *inhandle;
};

struct channel
{
  struct channel *next;
  struct channel *prev;
  struct server *server;
  struct list *topiclist;
  struct list *nicknamelist;
  FD_TopicListWindow *topiclistwin;
  FD_PasswordWindow *passwordwin;
  FD_MainWindow *window;
  FD_BanWindow *banwin;
  FL_OBJECT *channeltext;
  int isop;
  int voice;
  int logstart;
  int logging;
  int nickcomplete;
  int nickcompleting;
  char nickpost[LINELEN];
  char name[MAXCHANNEL];
  char password[LINELEN];
};

struct query
{
  struct server *server;
  FD_QueryWindow *window;
  FL_OBJECT *querytext;
  int logstart;
  char name[NICKLEN];
  char logname[NICKLEN];        // Falls sich der Nick whrend des Queries ndert
};

#endif /* CHANNEL_H */
