/* Morse.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Dekodierung eingehender Morsecodes */

#include <string.h>
#include "Morse.h"
#define MARK(x)       printf("Mark %d\n",x);    /* Debugging */

extern errorlogwindow;

char *morse[46]={".-"   ,"-..."  ,"-.-."  ,"-.."   ,"."     ,"..-."  ,"--."  ,"...." ,".."   ,
                 ".---" ,"-.-"   ,".-.."  ,"--"    ,"-."    ,"---"   ,".--." ,"--.-" ,".-."  ,
                 "..."  ,"-"     ,"..-"   ,"...-"  ,".--"   ,"-..-"  ,"-.--" ,"--.." ,"..-..",
                 ".----","..---" ,"...--" ,"....-" ,"....." ,"-...." ,"--...","---..","----.",
                 "-----",".-.-.-","--..--","---...","..--..","-....-","-..-.","-...-",".-.-.",
                 0},

     alpha[46]={'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t',
                'u','v','w','x','y','z','','1','2','3','4','5','6','7','8','9','0','.',',',':',
                '?','-','/','=','+',0};


int checkmorse(char *buffer)
{
  int count,morsecodes,code,percent;

  morsecodes=0;

  if(buffer && strlen(buffer))
  {
    count=0;
    while(code=buffer[count++])
    {
      if(code=='-' || code=='.') morsecodes++;
    }
//    printf("%d von %d (%d%%) (%s)\n",morsecodes,strlen(buffer),morsecodes*100/strlen(buffer),buffer);
    morsecodes=morsecodes*100/strlen(buffer);
  }
  return morsecodes;
}

char *decodemorse(char *buffer)
{
  int len,count,pointer;
  char letter[10],letterlen,code,*decoded;

  len=strlen(buffer);

  decoded=calloc(1,len);  /* Der dekodierte String kann nie lnger sein als das Original */
  if(decoded==0) logerror(errorlogwindow,"decodemorse(): decoded==0!");
  else
  {
    pointer=0;
    count=0;
    letterlen=0;
    letter[0]=0;

    while(count<=len)
    {
      code=buffer[count++];
      if(code=='-' || code=='.')
      {
        if(letterlen<9)
        {
          letter[letterlen++]=code;
          letter[letterlen]=0;
        }
      }
      else
      {
        if(strlen(decoded))
        {
          if(code && code!=' ') /* Kein Zeilenende und kein Leerzeichen? */
          {
            if(decoded[pointer-1]!=' ') 
            {
              strcat(decoded," ");
              pointer++;
            }
          }
        }

        if(letterlen)
        {
          int index;
          index=0;

          while(morse[index])
          {
            if(strcmp(morse[index],letter)==0)
            {  
//              printf("%c\n",alpha[index]);
              decoded[pointer++]=alpha[index];
            }
            index++;
          } // while

          letterlen=0;
        }
      }
    } // while
  }
  return decoded;
}
