void playsound(int audiochannel,struct sound *sound)
{
  long speed,count;
  int byte;

  speed=sound->speed;

  ioctl(audiochannel,SNDCTL_DSP_SPEED,&speed);
//  printf("%d\n",speed);

  if(sound->bits==16 && sound->stereo==1)
  {
    write(audiochannel,sound->rawdata,sound->length);
  }
  else
  {
//    printf("bits %d   channels %d\n",sound->bits,sound->stereo);

    for(count=0;count<sound->length;count++)
    {
      if(sound->bits==8)
      {
        byte=sound->rawdata[count];
        if(sound->amiga) byte+=128;          // +128 fr IFF8SVX-Samples
 
        write(audiochannel,&byte,1);
        if(sound->stereo==1) write(audiochannel,&byte,1);
      }
      else
      {
        byte=sound->rawdata[count]*256+sound->rawdata[count++];
        count++;
        write(audiochannel,&byte,2);
        if(sound->stereo==1) write(audiochannel,&byte,2);
      }
    } // endfor
  }
}

void preparesound(struct sound *sound)
{
  unsigned char *buffer;
  int audio,attempt;
  long samplesize,channels,buffersize;

  attempt=0;

  do
  {
    attempt++;

    samplesize=sound->bits;
    channels=sound->stereo;

    buffersize=65536;

    audio=open("/dev/dsp",O_WRONLY);

    if(audio==0) logerror(errorlogwindow,"preparesound(): open('/dev/dsp') failed.");
    else
    {
//    printf("samplesize %d\n",samplesize);

      if(ioctl(audio,SNDCTL_DSP_SAMPLESIZE,&samplesize)==-1) printf("preparesound(): samplesize(%d) failed\n",samplesize);
      else
      {
//      printf("channels %d\n",channels);

        if(ioctl(audio,SNDCTL_DSP_STEREO,&channels)==-1) printf("preparesound(): channels(%d) failed\n",channels);
        else
        {
          ioctl(audio,SNDCTL_DSP_GETBLKSIZE,&buffersize);
          buffer=malloc(buffersize);
          if(buffer==0) logerror(errorlogwindow,"preparesound(): malloc(buffer) failed.");
          else
          {
            memset(buffer,0,buffersize);
            playsound(audio,sound);
            free(buffer);
            attempt=0;
          }
        }
      }
      close(audio);
    }
  } while(attempt!=1000 && attempt!=0);
}
