/* Transmit.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr Transmit */

#include <forms.h>

#include "Transmit.h"
#include "Constants.h"
#include "FoxIRC.h"
#include "Query.h"
#include "Nick.h"

extern int doconnect;
extern struct preferences prefs;
extern struct channel *activechannel;
extern FD_IsOnWindow *isonwindow;
extern FD_ChannelListWindow *channellistwindow;
extern char dns[];

void transmitraw(int sock,char *string)
{
  if(string[0]!=0)
  {
    outscript(&prefs,string);
    /* \n anhngen wenn es noch nicht da ist */
    if(string[strlen(string)-1]!='\n') outscript(&prefs,"\n");
    printf("%s\n",string);
    write(sock,string,strlen(string));
    write(sock,"\n",1);
  }
}

void transmit(struct server *server,char *string)
{
  char sendstring[LINELEN+20],showstring[LINELEN+20],parse[LINELEN+20],querynick[NICKLEN];
  int count,pointer;
  struct node *querynode;

  sendstring[0]=0;
  showstring[0]=0;
  querynode=0;

  if(server==0)
  {
    if(strncasecmp(string+1,"CONNECT",7)==0)
    {
      doconnect=(server==0) ? 1 : 0;
    }

//    else if(strncasecmp(string+1,"SERVER ",7)==0)     // erfordert eine Umstrukturierung im Connect-Code
//    {
//      strcpy(server->name,string+8);
//      doconnect=(server==0) ? 1 : 0;
//    }

    else if(strncasecmp(string+1,"IGNORE ",7)==0)
    {
      if(strlen(string)<9) sprintf(showstring,"\\C%dFehler\tBefehlsformat: /IGNORE <nickname>",COL_PRG);
      else
      {
        addignore(prefs.ignorelist,string+8,0);
        writeprefs(&prefs);
        sprintf(showstring,"\\C%dInfo\tNick '%s' wird ab jetzt im Kanal ignoriert.",COL_PRG,string+8);
        info(showstring,activechannel);
        sendstring[0]=0;
      }
    }

    else if(strncasecmp(string+1,"IGNOREALL ",10)==0)
    {
      if(strlen(string)<12) sprintf(showstring,"\\C%dFehler\tBefehlsformat: /IGNOREALL <nickname>",COL_PRG);
      else
      {
        addignore(prefs.ignorelist,string+11,1);
        writeprefs(&prefs);
        sprintf(showstring,"\\C%dInfo\tNick '%s' wird ab jetzt im Kanal und in Queries ignoriert.",COL_PRG,string+11);
        info(showstring,activechannel);
        sendstring[0]=0;
      }
    }

    else
    {
      sprintf(showstring,"\\C%dFehler\tEs besteht keine Verbindung zu einem Server.",COL_PRG);
      info(showstring,0);
    }
  }
  else
  {
    if(string[0]=='/' && string[1]!='/')
    {
      int alias;

      strcpy(sendstring,string+1);

      /* Aliase berschreiben alle Kommandos */
      alias=checkalias(&prefs,string+1);
      if(alias!=-1)
      {
        processalias(&prefs,alias,string,server,activechannel);
        sendstring[0]=0;
      }
      else if(strncasecmp(string+1,"MSG ",4)==0)
      {
        querynick[0]=0;
        count=5;
        while(string[count]!=' ' && string[count]!=0) querynick[count-5]=string[count++];
        querynick[count-5]=0;
        printf("'%s'\n",querynick);

        if(strlen(querynick)!=0 && string[count]!=0)
        {
          querynode=getquerybyname(server,querynick);

          if(strncasecmp(string+count+1,"/ME",3)==0)
          {
            sprintf(sendstring,"PRIVMSG %s :%cACTION %s%c",querynick,1,string+count+5,1);
            if(querynode)
              sprintf(showstring,"\\C%d\t* %s %s",COL_QUERY,server->currentnick,string+count+5);
            else
              sprintf(showstring,"\\C%d>%s<\t* %s %s",COL_QUERY,querynick,server->currentnick,string+count+5);
          }
          else
          {
            sprintf(sendstring,"PRIVMSG %s :%s",querynick,string+count+1);
            if(querynode)
              sprintf(showstring,"\\C%d*%s*\t%s",COL_QUERY,server->currentnick,string+count+1);
            else
              sprintf(showstring,"\\C%d>%s<\t%s",COL_QUERY,querynick,string+count+1);
          }

          if(querynick[0]!='#' && querynick[0]!='&')   // Kanalmessage oder Query?
          {
            strcpy(server->lastquery,querynick);
            addquerynick(querynick);
          }
        }
      }

      else if(strncasecmp(string+1,"QUERY",5)==0)
      {
        if(string[6]==0 || string[7]==0)
        {
          sprintf(showstring,"\\C%dFehler\tKein Partner fr den Query angegeben.",COL_PRG);
          info(showstring,activechannel);
        }
        else
        {
          count=strlen(string)-1;
          while(count!=0 && string[count]==' ') string[count--]=0;    // Trim

          querynode=getquerybyname(server,string+7);
          if(querynode==0) querynode=addquery(server,string+7);
          if(querynode==0)
          {
            sprintf(showstring,"\\C%dFehler\tKonnte Query zu %s nicht ffnen.",COL_PRG,string+7);
            info(showstring,activechannel);
          }
        }

        sendstring[0]=0;
        showstring[0]=0;
      }

      else if(strncasecmp(string+1,"DESCRIBE ",9)==0)
      {
        querynick[0]=0;
        count=10;
        while(string[count]!=' ') querynick[count-10]=string[count++];
        querynick[count-10]=0;

        if(strlen(querynick)!=0)
        {
          querynode=getquerybyname(server,querynick);

          sprintf(sendstring,"PRIVMSG %s :%cACTION %s%c",querynick,1,string+count+1,1);
          if(querynode)
            sprintf(showstring,"\\C%d\t* %s %s",COL_QUERY,server->currentnick,string+count+1);
          else
            sprintf(showstring,"\\C%d>%s<\t* %s %s",COL_QUERY,querynick,server->currentnick,string+count+1);
          strcpy(server->lastquery,querynick);

          addquerynick(querynick);
        }
      }

      else if(strncasecmp(string+1,"INVITE ",7)==0)
      {
        count=0;
        while(string[count+8]!=' ' && string[count+8]!=0) querynick[count++]=string[count+8];
        querynick[count]=0;

        sprintf(sendstring,"INVITE %s %s",querynick,(string[count+8]==0) ? activechannel->name : string+count+9);
      }

      else if(strncasecmp(string+1,"CTCP ",5)==0)
      {
        count=0;
        while(string[count+6]!=' ' && string[count+6]!=0) querynick[count++]=string[count+6];
        querynick[count]=0;

        if(querynick[0]!=0 && string[count+6]!=0)
        {
          sprintf(sendstring,"PRIVMSG %s :%c%s%c",querynick,1,string+count+7,1);
          sprintf(showstring,"\\C%dCTCP\tSende CTCP-%s an %s.",COL_CTCP,string+count+7,querynick);
        }
      }

      else if(strncasecmp(string+1,"QUIT",4)==0)
      {
        parseaction(activechannel,prefs.quitmsg,parse,0);

        if(strlen(string)==5) sprintf(sendstring,"QUIT :%s",parse);
        else sprintf(sendstring,"QUIT :%s",string+6);

        sprintf(showstring,"\\C%dQuit\tDu hast den Server verlassen. (%s)",COL_PRG,parse);

        displayirc(showstring,0);
        showstring[0]=0;

        if(isonwindow!=0) fl_clear_browser(isonwindow->IsOnList);
        resetwindow(activechannel);
      }

      else if(strncasecmp(string+1,"CONNECT",7)==0) // || strncasecmp(string+1,"SERVER",6)==0)
      {
        sprintf(showstring,"\\C%dFehler\tConnect: Es besteht bereits eine Server-Verbindung.",COL_PRG);
        sendstring[0]=0;
      }

      else if(strncasecmp(string+1,"DNS",3)==0)
      {
        sendstring[0]=0;

        if(string[4]==' ')
        {
          strcpy(dns,string+5);
          while(dns[strlen(dns)-1]==' ') dns[strlen(dns)-1]=0;       // trim
          sprintf(sendstring,"WHOIS %s",string+5);
        }
        else
        {
          sprintf(showstring,"\\C%dFehler\tDNS: Befehlsformat: /DNS <nickname>",COL_PRG);
        }
      }
      else if(strncasecmp(string+1,"BAN",3)==0)
      {
        sendstring[0]=0;

        if(string[4]==0 || string[5]==0) sprintf(showstring,"\\C%dFehler\tBAN: Befehlsformat: /BAN <nickname|hostmask>",COL_PRG);
        else
        {
          char *parameter;
          int banned;

          banned=0;

          parameter=string+5;

          if(activechannel)
          {
            struct node *node;

            node=getnicknode(activechannel->nicknamelist,parameter);
            if(node)
            {
              struct nick *nick;

              nick=node->data;
              if(nick->hostmask)
              {
                char *hostmask,*atindex;
                char banmask[LINELEN];
                /* suche Position des @ in der Hostmask */
                atindex=rindex(nick->hostmask,'@');
                /* suche nchsten "." nach dem @ */
                hostmask=strstr(atindex,".");

                sprintf(banmask,"*!*@*%s",hostmask);
                ban(activechannel,banmask);
                banned=1;
              }
            }
          }
          if(!banned) ban(activechannel,parameter);
        }
      }
      else if(strncasecmp(string+1,"UNBAN",5)==0)
      {
        sendstring[0]=0;

        if(string[6]==0 || string[7]==0) sprintf(showstring,"\\C%dFehler\tUNBAN: Befehlsformat: /UNBAN <nickname|hostmask>",COL_PRG);
        else
        {
          char *parameter;
          int unbanned;

          unbanned=0;

          parameter=string+7;

          if(activechannel)
          {
            struct node *node;

            node=getnicknode(activechannel->nicknamelist,parameter);
            if(node)
            {
              struct nick *nick;

              nick=node->data;
              if(nick->hostmask)
              {
                char *hostmask,*atindex;
                char banmask[LINELEN];
                /* suche Position des @ in der Hostmask */
                atindex=rindex(nick->hostmask,'@');
                /* suche nchsten "." nach dem @ */
                hostmask=strstr(atindex,".");

                sprintf(banmask,"*!*@*%s",hostmask);
                unban(activechannel,banmask);
                unbanned=1;
              }
            }
          }
          if(!unbanned) unban(activechannel,parameter);
        }
      }

      else if(strncasecmp(string+1,"ISON",4)==0);   // Server-Kommandos unverndert lassen
      else if(strncasecmp(string+1,"NAMES",5)==0);
      else if(strncasecmp(string+1,"NICK",4)==0);
      else if(strncasecmp(string+1,"MODE",4)==0);
      else if(strncasecmp(string+1,"JOIN",4)==0);
      else if(strncasecmp(string+1,"WHOIS",5)==0);
      else if(strncasecmp(string+1,"PRIVMSG",7)==0);

      else if(strncasecmp(string+1,"AWAY",4)==0)
      {
        if(string[5]==0)
        {
          sprintf(sendstring,"AWAY");
        }
        else
        {
          if(string[5]==' ')
          {
            sprintf(sendstring,"AWAY :%s",string+6);
          }
          else
          {
            sprintf(showstring,"\\C%dFehler\t/AWAY [Abwesenheitsgrund]",COL_PRG);
            sendstring[0]=0;
          }
        }
      }

      else if(strncasecmp(string+1,"LIST",4)==0)
      {
        if(channellistwindow!=0)                    // Kanalliste lschen
        {
          fl_clear_browser(channellistwindow->ChannelList);
          fl_clear_browser(channellistwindow->NumofList);
          fl_clear_browser(channellistwindow->TopicList);
        }
      }

      else if(activechannel==0)
      {
        sprintf(showstring,"\\C%dFehler\tEs ist kein Chatkanal aktiv.",COL_PRG);
        info(showstring,0);
        sendstring[0]=0;
        showstring[0]=0;
      }
      else
      {
        if(strncasecmp(string+1,"PART",4)==0)
        {
          if(strlen(string)==5) sprintf(sendstring,"PART %s :%s",activechannel->name,prefs.quitmsg);
          else sprintf(sendstring,"PART %s :%s",activechannel->name,string+6);

          parseaction(activechannel,sendstring,parse,0);
          strcpy(sendstring,parse);
        }

        // Ja, ich wei, das ist doppelt.
        if(strncasecmp(string+1,"LEAVE",5)==0)
        {
          if(strlen(string)==6) sprintf(sendstring,"PART %s :%s",activechannel->name,prefs.quitmsg);
          else sprintf(sendstring,"PART %s :%s",activechannel->name,string+7);

          parseaction(activechannel,sendstring,parse,0);
          strcpy(sendstring,parse);
        }

        else if(strncasecmp(string+1,"ME ",3)==0)
        {
          sprintf(sendstring,"PRIVMSG %s :%cACTION %s%c",activechannel->name,1,string+4,1);
          sprintf(showstring,"\\C%d\t* %s %s",COL_ACTION,server->currentnick,string+4);
        }

        else if(strncasecmp(string+1,"TOPIC ",6)==0)
        {
          if(string[7]!='#' && string[7]!='&') sprintf(sendstring,"TOPIC %s :%s",activechannel->name,string+7);
        }

        else if(strncasecmp(string+1,"MORSE ",6)==0)
        {
          sprintf(sendstring,"PRIVMSG %s :",activechannel->name);
          sprintf(showstring,"\\C%d%s:\t",COL_TEXT,server->currentnick);

          for(count=7;string[count]!=0;count++)
          {
            pointer=0;
            while(tolower(string[count])!=alpha[pointer] && pointer!=46) pointer++;

            if(pointer==46)
            {
              if(string[count]==' ')
              {
                strcat(showstring," / ");
                strcat(sendstring," / ");
              }
              else
              {
                strncat(showstring,string+count,1);
                strncat(sendstring,string+count,1);
              }
            }
            else
            {
              strcat(showstring,morse[pointer]);
              strcat(sendstring,morse[pointer]);

              strcat(showstring," ");
              strcat(sendstring," ");
            }
          } // endfor
        }

        else if(strncasecmp(string+1,"KICK ",5)==0)
        {
          char *reason,kicknick[NICKLEN+1];
          int count,kickcount;

          if(string[6])
          {
            count=6;
            kickcount=0;

            while(string[count] && string[count]!=' ')
            {
              if(kickcount!=NICKLEN) kicknick[kickcount++]=string[count++];
              kicknick[kickcount]=0;
            }
            reason=string+count;

            sprintf(sendstring,"KICK %s %s :%s",activechannel->name,kicknick,(reason[0]) ? reason+1 : prefs.kickmsg);
          }
        }

        else if(strncasecmp(string+1,"OP ",3)==0) sprintf(sendstring,"MODE %s +o %s",activechannel->name,string+4);
        else if(strncasecmp(string+1,"DEOP ",5)==0) sprintf(sendstring,"MODE %s -o %s",activechannel->name,string+6);
        else if(strncasecmp(string+1,"VOICE ",6)==0) sprintf(sendstring,"MODE %s +v %s",activechannel->name,string+7);
        else if(strncasecmp(string+1,"UNVOICE ",8)==0) sprintf(sendstring,"MODE %s -v %s",activechannel->name,string+9);

        else if(strcasecmp(string+1,"VISIBLE")==0) sprintf(sendstring,"MODE %s -i",server->currentnick);
        else if(strcasecmp(string+1,"INVISIBLE")==0) sprintf(sendstring,"MODE %s +i",server->currentnick);

      }
    }
    else
    {
      if(activechannel==0) sprintf(showstring,"\\C%dFehler\tEs ist kein Chatkanal aktiv.",COL_PRG);
      else
      {
        sprintf(sendstring,"PRIVMSG %s :%s",activechannel->name,(string[0]=='/') ? string+1 : string);
        sprintf(showstring,"\\C%d%s%s:\t%s",COL_TEXT,(server->currentnick[0]=='\\') ? "\\" : "",server->currentnick,(string[0]=='/') ? string+1 : string);
      }
    }

    transmitraw(server->sock,sendstring);

    if(showstring[0]==0); // displayirc(string,activechannel->channeltext);
    else
    {
      if(querynode==0) displayirc(showstring,activechannel);
      else
      {
        struct query *query=querynode->data;
        displayquery(query,showstring,0);
      }
    }
  }
}

